## START: Set by rpmautospec
## (rpmautospec version 0.2.5)
%define autorelease(e:s:pb:) %{?-p:0.}%{lua:
    release_number = 2;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{?dist}
## END: Set by rpmautospec

# EPEL is missing dependencies required for docs
%if 0%{?rhel}
%bcond_with docs
%else
%bcond_without docs
%endif

%bcond_without tests

%global modname testslide
%global pypi_name TestSlide
%global obs_verrel 2.6.4-99

Name:           python-%{pypi_name}
Version:        2.7.0
Release:        %autorelease
Summary:        A Python test framework

License:        MIT
URL:            https://github.com/facebook/TestSlide
# The PyPI tarball doesn't include tests, so use the original source instead
Source:         %{url}/archive/%{version}/%{pypi_name}-%{version}.tar.gz
# the specified psutil version is newer than in EL8 appstream
Patch:          %{pypi_name}-2.7.0-lower-psutil.patch
BuildArch:      noarch

BuildRequires:  python3-devel
BuildRequires:  python3dist(setuptools) >= 38.6
BuildRequires:  sed

%if %{with docs}
# Docs requirements
BuildRequires:  make
BuildRequires:  ncurses
BuildRequires:  python3-ipython
BuildRequires:  python3dist(sphinx)
BuildRequires:  python3dist(sphinx-kr-theme)
%endif

%if %{with tests}
# Test requirements
BuildRequires:  python3dist(pytest)
BuildRequires:  python3dist(psutil)
BuildRequires:  python3dist(pygments)
BuildRequires:  python3dist(typeguard)
%endif

%global _description %{expand:
A test framework for Python that enable unit testing / TDD / BDD to be
productive and enjoyable.

Its well behaved mocks with thorough API validations catches bugs both
when code is first written or long in the future when it is changed.

The flexibility of using them with existing unittest.TestCase or TestSlide's
own test runner let users get its benefits without requiring refactoring
existing code.}

%description %{_description}


%package -n     python3-%{modname}
Summary:        %{summary}
Provides:       python3-%{pypi_name} = %{version}-%{release}
Obsoletes:      python3-%{pypi_name} < %{obs_verrel}

%description -n python3-%{modname} %{_description}


%if %{with docs}
%package -n     python3-%{modname}-docs
Summary:        Documentation for python3-%{pypi_name}
Provides:       python3-%{pypi_name}-docs = %{version}-%{release}
Obsoletes:      python3-%{pypi_name}-docs < %{obs_verrel}

%description -n python3-%{modname}-docs %{_description}

The python3-%{modname}-docs package contains documentation for
python3-%{modname}.
%endif


%prep
%autosetup -n %{pypi_name}-%{version} -p1


%build
%py3_build
%if %{with docs}
make docs V=1
%endif


%install
%py3_install


%if %{with tests}
%check
# remove flaky tests
rm tests/cli_unittest.py
%pytest tests/*_unittest.py
%endif


%files -n python3-%{modname}
%license LICENSE
%doc README.md
%{_bindir}/testslide
%{python3_sitelib}/testslide
%{python3_sitelib}/%{pypi_name}-%{version}-py%{python3_version}.egg-info

%if %{with docs}
%files -n python3-%{modname}-docs
%doc docs/_build/html
%endif


%changelog
* Fri Apr 08 2022 Michel Alexandre Salim <salimma@fedoraproject.org> 2.7.0-2
- Lower the psutil version requirement

* Thu Jan  6 2021 Michel Alexandre Salim <salimma@fedoraproject.org> - 2.7.0-1
- Update to 2.7.0
- Actually run tests

* Tue Jan  5 2021 Davide Cavalca <dcavalca@fedoraproject.org> - 2.6.4-2
- Backport PR#271, PR#272 and PR#273 to adjust requirements for EPEL 8

* Sat Jan  2 2021 Davide Cavalca <dcavalca@fedoraproject.org> - 2.6.4-1
- New upstream release

* Wed Dec 30 2020 Davide Cavalca <dcavalca@fedoraproject.org> - 2.6.3-2
- Build for EPEL 8

* Thu Nov 12 2020 Davide Cavalca <dcavalca@fedoraproject.org> - 2.6.3-1
- New upstream release

* Mon Nov  2 2020 Davide Cavalca <dcavalca@fedoraproject.org> - 2.6.1-3
- Backport PR#260, PR#261, PR#262
- Add py_provides for F32
- Build and package docs
- Run tests

* Tue Oct 27 2020 Davide Cavalca <dcavalca@fb.com> - 2.6.1-2
- Update BuildRequires
- Remove unneeded shebangs
- Drop unnecessary python_provide macro

* Tue Oct 27 2020 Davide Cavalca <dcavalca@fb.com> - 2.6.1-1
- Initial package
- Disable tests and docs for now

